/// <reference types="youtube" />
import { OnInit, AfterViewInit, OnDestroy, EventEmitter } from '@angular/core';
import { YTPlayerService } from './ytplayer.service';
export declare class YTPlayerComponent implements OnInit, AfterViewInit, OnDestroy {
    private ytPlayerService;
    videoId: string;
    domId: string;
    parameters: string | YT.PlayerVars;
    ready: EventEmitter<any>;
    unstarted: EventEmitter<any>;
    ended: EventEmitter<any>;
    playing: EventEmitter<any>;
    paused: EventEmitter<any>;
    buffering: EventEmitter<any>;
    cued: EventEmitter<any>;
    readonly currentTime: number;
    private player;
    private isReady;
    constructor(ytPlayerService: YTPlayerService);
    ngOnInit(): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    play(): void;
    pause(): void;
    cueVideoById(videoId: string, startSeconds?: number): void;
    loadVideoById(videoId: string, startSeconds?: number): void;
    private onplay;
    private initPlayer;
}
